/* JavaPickle.java */
/* Chris Jacobi, April 20, 1997 8:39 pm PDT */
/* $Id: JavaPickle.java,v 1.1 1997/04/22 23:21:47 jacobi Exp $ */

/*

Sofar we don't transfer byte codes...
Nice exercise for the reader

*/


/* Need to raise exceptions instead of printing to System.err ... */


package javaserial;

public class JavaPickle extends javaserial.JavaPickleBase {
    private static final byte[] empty = new byte[0]; 
    private static final Object lock = new Object(); 
    private java.lang.Object theObject = null; //synchronized with super.bs
    
    static { //this makes javaserial.JavaPickleBase "smart"
        try {
            javaserial._allJavaStubs.load();
            _theClass = 
                java.lang.Class.forName("javaserial.JavaPickle");
        } catch (java.lang.Exception e) {
            System.err.println("Exception while loading JavaPickle: " 
                + e );
        }
    }
    
    public static void load() {
    }
    
    public JavaPickle() {
        try {
            setObject(null);
        } catch (java.io.IOException e) {
            throw new java.lang.RuntimeException();
        }
    }
    
    public JavaPickle(java.io.Serializable sob) throws java.io.IOException {
        setObject(sob);
    } 
    
    public java.lang.Object getObject() 
            throws java.io.IOException, java.lang.ClassNotFoundException  {
        if (this.theObject != null) return this.theObject;
        byte[] ba = this.bs;
        if (ba == null || ba.length == 0) return null;
        System.out.println("getObject");
        java.io.ByteArrayInputStream in 
            = new java.io.ByteArrayInputStream(ba);
        java.io.ObjectInputStream s = new MyObjectInputStream(this, in);
        Object obj = s.readObject();
        System.out.println("getObject got: " + obj);
        synchronized (lock) {
            if (this.bs == ba) this.theObject = obj;
        }
        return this.theObject;
    } //getObject
    
    
    public void setObject(java.io.Serializable sob) throws java.io.IOException {
        if (sob == null) {
            synchronized (lock) {
                this.theObject = null;
                this.bs = empty;
            }
            return;
        }
        System.out.println("setObject: " + sob);
        java.io.ByteArrayOutputStream bstream  
            = new java.io.ByteArrayOutputStream();
        java.io.ObjectOutput ostream 
            = new java.io.ObjectOutputStream(bstream);
        ostream.writeObject(sob);
        ostream.flush();
        byte[] ba = bstream.toByteArray();
        synchronized (lock) {
            this.theObject = sob;
            this.bs = ba;
        }
        bstream.reset();
        System.out.println("setObject done");
    } //setObject
    
    
} //JavaPickle


class MyObjectInputStream extends java.io.ObjectInputStream {
    
    private JavaPickle container;
    
    public MyObjectInputStream(JavaPickle container, java.io.InputStream s) 
            throws java.io.IOException, java.io.StreamCorruptedException {
        super(s);
        this.container = container;
    }
    
    protected java.lang.Class resolveClass(java.io.ObjectStreamClass v)
            throws java.io.IOException, java.lang.ClassNotFoundException {
        java.lang.Class clazz = null;
        String name = v.getName();
        System.out.println("resolveClass: " + name);
        //
        // Now check your class loader and optionally use 
        // container.accessor.GetBytes(name)
        // to get the actual bytes
        //
        clazz = super.resolveClass(v);
        return clazz;
    } //resolveClass
    
} //MyObjectInputStream
